/*
 * Java Othello Openings Applet
 * Copyright (C) 2000 Bill Lorton
 * email: hogarth1@yahoo.com
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

import java.awt.*;

/**
 *
 * A helper class to simplify the use of the GridBag container.
 *
 * @version 1.00
 * @author Bill Lorton
 *
 */
class GBHelper {
  private void _constrain(
		 Container container,
		 Component component,
		 int       grid_x,
		 int       grid_y,
		 int       grid_width,
		 int       grid_height,
		 int       fill,
		 int       anchor,
		 double    weight_x,
		 double    weight_y,
		 int       top,
		 int       left,
		 int       bottom,
		 int       right
	       )
  {
    GridBagConstraints c = new GridBagConstraints();

    c.gridx      = grid_x;
    c.gridy      = grid_y;
    c.gridwidth  = grid_width;
    c.gridheight = grid_height;
    c.fill       = fill;
    c.anchor     = anchor;
    c.weightx    = weight_x;
    c.weighty    = weight_y;

    if (top+bottom+left+right > 0)
      c.insets = new Insets(top,left,bottom,right);

    ((GridBagLayout)container.getLayout()).setConstraints(component,c);
    container.add(component);
  }

  public void constrain(
	        Container container,
	        Component component,
	        int       grid_x,
	        int       grid_y,
	        int       grid_width,
	        int       grid_height
	      )
  {
    _constrain(
      container,
      component,
      grid_x,
      grid_y,
      grid_width,
      grid_height,
      GridBagConstraints.NONE,
      GridBagConstraints.NORTHWEST,
      0.0,
      0.0,
      0,
      0,
      0,
      0
    );
  }

  public void constrainFill(
	        Container container,
	        Component component,
	        int       grid_x,
	        int       grid_y,
	        int       grid_width,
	        int       grid_height
	      )
  {
    _constrain(
      container,
      component,
      grid_x,
      grid_y,
      grid_width,
      grid_height,
      GridBagConstraints.BOTH,
      GridBagConstraints.NORTHWEST,
      0.0,
      0.0,
      0,
      0,
      0,
      0
    );
  }

  public void constrain(
	        Container container,
	        Component component,
	        int       grid_x,
	        int       grid_y,
	        int       grid_width,
	        int       grid_height,
	        int       top,
	        int       left,
	        int       bottom,
	        int       right
	      )
  {
    _constrain(
      container,
      component,
      grid_x,
      grid_y,
      grid_width,
      grid_height,
      GridBagConstraints.NONE,
      GridBagConstraints.NORTHWEST,
      0.0,
      0.0,
      top,
      left,
      bottom,
      right
    );
  }
  public void constrainFill(
	        Container container,
	        Component component,
	        int       grid_x,
	        int       grid_y,
	        int       grid_width,
	        int       grid_height,
	        int       top,
	        int       left,
	        int       bottom,
	        int       right
	      )
  {
    _constrain(
      container,
      component,
      grid_x,
      grid_y,
      grid_width,
      grid_height,
      GridBagConstraints.BOTH,
      GridBagConstraints.NORTHWEST,
      0.0,
      0.0,
      top,
      left,
      bottom,
      right
    );
  }
}
