/*
 * Java Othello Openings Applet
 * Copyright (C) 2000 Bill Lorton
 * email: hogarth1@yahoo.com
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/**
 *
 * A generic singly linked list node.
 *
 * @version 1.00
 * @author Bill Lorton
 *
 */
class Node extends Object {
  private Node _next;

  /**
   *
   * The Node constructor.
   *
   */
  public Node()  { _next = null; }

  /**
   *
   * Sets the next node of this node.
   *
   * @param n the node to set as the next node
   *
   */
  public void setNext(Node n) { _next = n; }

  /**
   *
   * Gets the next node from this node.
   *
   * @return the next node
   *
   */
  public Node next() { return _next; }
}

