/*
 * Java Othello Openings Applet
 * Copyright (C) 2000 Bill Lorton
 * email: hogarth1@yahoo.com
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/**
 *
 * Handles the play feature of the applet.
 *
 * @version 1.00
 * @author Bill Lorton
 *
 */
class PlayerThread extends Thread {
  private static final long DELAY     = 1500;
  private static final long END_DELAY = DELAY*2;

  private Othello _applet;

  public PlayerThread(Othello app)
  {
    _applet = app;
  }

  /**
   *
   * Call this method to start playing through the moves.
   *
   */
  public void run()
  {
    for (;;) {
      if (_applet.atLastMove())
	_applet.firstMove();
      else
	_applet.nextMove();

      try {
	if (_applet.atLastMove())
	  sleep(END_DELAY);
	else
	  sleep(DELAY);
      }
      catch (InterruptedException ie) {
	break;
      }
    }
  }
}

