/*
 * Java Othello Openings Applet
 * Copyright (C) 2000 Bill Lorton
 * email: hogarth1@yahoo.com
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/**
 *
 * A generic hierarchical tree node.
 *
 * @version 1.00
 * @author Bill Lorton
 *
 */
class TreeNode extends Node {
  private TreeNode _parent;
  private TreeNode _child;


  /**
   *
   * The TreeNode constructor.
   *
   */
  public TreeNode() { _parent = null; _child = null; }


  /**
   *
   * Sets the parent of this node.
   *
   * @param n the node to set as the parent
   *
   */
  public void setParent(TreeNode n)
  {
    _parent = n;
  }


  /**
   *
   * Adds a node to then end of this node's child list and updates the child's
   * parent node to be this node.
   *
   * @param n the node to add as a child
   *
   */
  public void addChild(TreeNode n)
  {
    if (_child==null)
      _child = n;
    else {
      TreeNode c = _child;

      while (c.next()!=null)
        c = (TreeNode)c.next();

      c.setNext(n);
    }

    n.setParent(this);
  }


  /**
   *
   * Gets the parent of this node.
   *
   * @return the parent of this node
   *
   */
  public TreeNode parent() { return _parent; }


  /**
   *
   * Gets the first child of this node.
   *
   * @return the first child of this node
   *
   */
  public TreeNode child()  { return _child; }
}

